Index: /branches/HiveProjectManagement/HeuristicLab.Clients.Hive.Administrator/3.3/Views/ResourcesView.Designer.cs
===================================================================
--- /branches/HiveProjectManagement/HeuristicLab.Clients.Hive.Administrator/3.3/Views/ResourcesView.Designer.cs	(revision 15421)
+++ /branches/HiveProjectManagement/HeuristicLab.Clients.Hive.Administrator/3.3/Views/ResourcesView.Designer.cs	(revision 15422)
@@ -37,9 +37,4 @@
         components.Dispose();
       }
-      HiveAdminClient.Instance.Refreshing -= new EventHandler(HiveAdminClient_Instance_Refreshing);
-      HiveAdminClient.Instance.Refreshed -= new EventHandler(HiveAdminClient_Instance_Refreshed);
-
-      Access.AccessClient.Instance.Refreshing -= new EventHandler(AccessClient_Instance_Refreshing);
-      Access.AccessClient.Instance.Refreshed -= new EventHandler(AccessClient_Instance_Refreshed);
       base.Dispose(disposing);
     }
@@ -59,11 +54,11 @@
       this.btnRemoveGroup = new System.Windows.Forms.Button();
       this.btnAddGroup = new System.Windows.Forms.Button();
-      this.treeSlaveGroup = new System.Windows.Forms.TreeView();
+      this.treeView = new System.Windows.Forms.TreeView();
       this.tabSlaveGroup = new System.Windows.Forms.TabControl();
       this.tabDetails = new System.Windows.Forms.TabPage();
+      this.viewHost = new HeuristicLab.MainForm.WindowsForms.ViewHost();
       this.tabSchedule = new System.Windows.Forms.TabPage();
+      this.scheduleView = new HeuristicLab.Clients.Hive.Administrator.Views.ScheduleView();
       this.toolTip = new System.Windows.Forms.ToolTip(this.components);
-      this.slaveView = new HeuristicLab.Clients.Hive.Administrator.Views.SlaveView();
-      this.scheduleView = new HeuristicLab.Clients.Hive.Administrator.Views.ScheduleView();
       ((System.ComponentModel.ISupportInitialize)(this.splitSlaves)).BeginInit();
       this.splitSlaves.Panel1.SuspendLayout();
@@ -95,5 +90,5 @@
       this.splitSlaves.Panel1.Controls.Add(this.btnRemoveGroup);
       this.splitSlaves.Panel1.Controls.Add(this.btnAddGroup);
-      this.splitSlaves.Panel1.Controls.Add(this.treeSlaveGroup);
+      this.splitSlaves.Panel1.Controls.Add(this.treeView);
       // 
       // splitSlaves.Panel2
@@ -117,5 +112,5 @@
       // btnSave
       // 
-      this.btnSave.Image = HeuristicLab.Common.Resources.VSImageLibrary.PublishToWeb;
+      this.btnSave.Image = HeuristicLab.Common.Resources.VSImageLibrary.Save;
       this.btnSave.Location = new System.Drawing.Point(93, 3);
       this.btnSave.Name = "btnSave";
@@ -148,23 +143,23 @@
       this.btnAddGroup.Click += new System.EventHandler(this.btnAddGroup_Click);
       // 
-      // treeSlaveGroup
-      // 
-      this.treeSlaveGroup.AllowDrop = true;
-      this.treeSlaveGroup.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
-            | System.Windows.Forms.AnchorStyles.Left) 
-            | System.Windows.Forms.AnchorStyles.Right)));
-      this.treeSlaveGroup.ImageIndex = 0;
-      this.treeSlaveGroup.ImageList = this.imageListSlaveGroups;
-      this.treeSlaveGroup.Location = new System.Drawing.Point(3, 33);
-      this.treeSlaveGroup.Name = "treeSlaveGroup";
-      this.treeSlaveGroup.SelectedImageIndex = 0;
-      this.treeSlaveGroup.Size = new System.Drawing.Size(243, 511);
-      this.treeSlaveGroup.TabIndex = 0;
-      this.treeSlaveGroup.ItemDrag += new System.Windows.Forms.ItemDragEventHandler(this.treeSlaveGroup_ItemDrag);
-      this.treeSlaveGroup.AfterSelect += new System.Windows.Forms.TreeViewEventHandler(this.treeSlaveGroup_AfterSelect);
-      this.treeSlaveGroup.DragDrop += new System.Windows.Forms.DragEventHandler(this.treeSlaveGroup_DragDrop);
-      this.treeSlaveGroup.DragEnter += new System.Windows.Forms.DragEventHandler(this.treeSlaveGroup_DragEnter);
-      this.treeSlaveGroup.DragOver += new System.Windows.Forms.DragEventHandler(this.treeSlaveGroup_DragOver);
-      this.treeSlaveGroup.QueryContinueDrag += new System.Windows.Forms.QueryContinueDragEventHandler(this.treeSlaveGroup_QueryContinueDrag);
+      // treeView
+      // 
+      this.treeView.AllowDrop = true;
+      this.treeView.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
+            | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
+      this.treeView.ImageIndex = 0;
+      this.treeView.ImageList = this.imageListSlaveGroups;
+      this.treeView.Location = new System.Drawing.Point(3, 33);
+      this.treeView.Name = "treeView";
+      this.treeView.SelectedImageIndex = 0;
+      this.treeView.Size = new System.Drawing.Size(243, 511);
+      this.treeView.TabIndex = 0;
+      this.treeView.ItemDrag += new System.Windows.Forms.ItemDragEventHandler(this.treeSlaveGroup_ItemDrag);
+      this.treeView.AfterSelect += new System.Windows.Forms.TreeViewEventHandler(this.treeSlaveGroup_AfterSelect);
+      this.treeView.DragDrop += new System.Windows.Forms.DragEventHandler(this.treeSlaveGroup_DragDrop);
+      this.treeView.DragEnter += new System.Windows.Forms.DragEventHandler(this.treeSlaveGroup_DragEnter);
+      this.treeView.DragOver += new System.Windows.Forms.DragEventHandler(this.treeSlaveGroup_DragOver);
+      this.treeView.QueryContinueDrag += new System.Windows.Forms.QueryContinueDragEventHandler(this.treeSlaveGroup_QueryContinueDrag);
       // 
       // tabSlaveGroup
@@ -180,9 +175,8 @@
       this.tabSlaveGroup.Size = new System.Drawing.Size(585, 541);
       this.tabSlaveGroup.TabIndex = 1;
-      this.tabSlaveGroup.SelectedIndexChanged += new System.EventHandler(this.tabSlaveGroup_SelectedIndexChanged);
       // 
       // tabDetails
       // 
-      this.tabDetails.Controls.Add(this.slaveView);
+      this.tabDetails.Controls.Add(this.viewHost);
       this.tabDetails.Location = new System.Drawing.Point(4, 22);
       this.tabDetails.Name = "tabDetails";
@@ -192,4 +186,20 @@
       this.tabDetails.Text = "Details";
       this.tabDetails.UseVisualStyleBackColor = true;
+      // 
+      // viewHost
+      // 
+      this.viewHost.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
+            | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
+      this.viewHost.Caption = "View";
+      this.viewHost.Content = null;
+      this.viewHost.Enabled = false;
+      this.viewHost.Location = new System.Drawing.Point(6, 6);
+      this.viewHost.Name = "viewHost";
+      this.viewHost.ReadOnly = false;
+      this.viewHost.Size = new System.Drawing.Size(565, 503);
+      this.viewHost.TabIndex = 0;
+      this.viewHost.ViewsLabelVisible = true;
+      this.viewHost.ViewType = null;
       // 
       // tabSchedule
@@ -203,17 +213,4 @@
       this.tabSchedule.Text = "Schedule";
       this.tabSchedule.UseVisualStyleBackColor = true;
-      // 
-      // slaveView
-      // 
-      this.slaveView.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
-            | System.Windows.Forms.AnchorStyles.Left) 
-            | System.Windows.Forms.AnchorStyles.Right)));
-      this.slaveView.Caption = "SlaveView";
-      this.slaveView.Content = null;
-      this.slaveView.Location = new System.Drawing.Point(6, 6);
-      this.slaveView.Name = "slaveView";
-      this.slaveView.ReadOnly = false;
-      this.slaveView.Size = new System.Drawing.Size(565, 503);
-      this.slaveView.TabIndex = 0;
       // 
       // scheduleView
@@ -253,9 +250,8 @@
     private System.Windows.Forms.Button btnRemoveGroup;
     private System.Windows.Forms.Button btnAddGroup;
-    private System.Windows.Forms.TreeView treeSlaveGroup;
+    private System.Windows.Forms.TreeView treeView;
     private System.Windows.Forms.TabControl tabSlaveGroup;
     private System.Windows.Forms.TabPage tabDetails;
     private System.Windows.Forms.TabPage tabSchedule;
-    private SlaveView slaveView;
     private System.Windows.Forms.ImageList imageListSlaveGroups;
     private ScheduleView scheduleView;
@@ -263,4 +259,5 @@
     private System.Windows.Forms.Button btnRefresh;
     private System.Windows.Forms.ToolTip toolTip;
+    private MainForm.WindowsForms.ViewHost viewHost;
   }
 }
Index: /branches/HiveProjectManagement/HeuristicLab.Clients.Hive.Administrator/3.3/Views/ResourcesView.cs
===================================================================
--- /branches/HiveProjectManagement/HeuristicLab.Clients.Hive.Administrator/3.3/Views/ResourcesView.cs	(revision 15421)
+++ /branches/HiveProjectManagement/HeuristicLab.Clients.Hive.Administrator/3.3/Views/ResourcesView.cs	(revision 15422)
@@ -21,4 +21,5 @@
 
 using System;
+using System.Collections.Generic;
 using System.ComponentModel;
 using System.Drawing;
@@ -37,13 +38,11 @@
   [Content(typeof(IItemList<Resource>), false)]
   public partial class ResourcesView : ItemView, IDisposable {
-    private const string UngroupedGroupName = "UNGROUPED";
     private const int slaveImageIndex = 0;
     private const int slaveGroupImageIndex = 1;
+    public const string ungroupedGroupName = "UNGROUPED";
+    public const string ungroupedGroupDescription = "Contains slaves that are not assigned to any group.";
 
     private readonly Color ownedResourceColor = Color.LightGreen;
     private readonly object locker = new object();
-    private bool updatingResources = false;
-    private bool removingResources = false;
-    private bool savingResources = false;
 
     public new IItemList<Resource> Content {
@@ -55,6 +54,6 @@
       InitializeComponent();
 
-      treeSlaveGroup.ImageList.Images.Add(VSImageLibrary.MonitorLarge);
-      treeSlaveGroup.ImageList.Images.Add(VSImageLibrary.NetworkCenterLarge);
+      treeView.ImageList.Images.Add(VSImageLibrary.MonitorLarge);
+      treeView.ImageList.Images.Add(VSImageLibrary.NetworkCenterLarge);
 
       HiveAdminClient.Instance.Refreshing += HiveAdminClient_Instance_Refreshing;
@@ -88,47 +87,10 @@
       base.OnContentChanged();
       if (Content == null) {
-        slaveView.Content = null;
+        treeView.Nodes.Clear();
+        viewHost.Content = null;
         scheduleView.Content = null;
-        treeSlaveGroup.Nodes.Clear();
       } else {
-        treeSlaveGroup.Nodes.Clear();
-
-        //rebuild
-        TreeNode ungrp = new TreeNode(UngroupedGroupName);
-        ungrp.ImageIndex = slaveGroupImageIndex;
-        ungrp.SelectedImageIndex = ungrp.ImageIndex;
-        var newGroup = new SlaveGroup();
-        newGroup.Name = UngroupedGroupName;
-        newGroup.Id = Guid.NewGuid();
-        newGroup.Description = "Contains slaves which are in no group";
-        ungrp.Tag = newGroup;
-
-        foreach (Resource g in Content.OrderBy(x => x.Name)) {
-          if (g.GetType() == typeof(SlaveGroup)) {
-            //root node
-            if (g.ParentResourceId == null) {
-              TreeNode tn = new TreeNode();
-              tn.ImageIndex = slaveGroupImageIndex;
-              tn.SelectedImageIndex = tn.ImageIndex;
-
-              tn.Tag = g;
-              tn.Text = g.Name;
-              if (g.OwnerUserId == Access.UserInformation.Instance.User.Id) tn.BackColor = ownedResourceColor;
-
-              BuildSlaveGroupTree(g, tn);
-              treeSlaveGroup.Nodes.Add(tn);
-            }
-          } else if (g.GetType() == typeof(Slave)) {
-            if (g.ParentResourceId == null) {
-              var stn = new TreeNode(g.Name);
-              stn.ImageIndex = slaveImageIndex;
-              stn.SelectedImageIndex = stn.ImageIndex;
-              stn.Tag = g;
-              if (g.OwnerUserId == Access.UserInformation.Instance.User.Id) stn.BackColor = ownedResourceColor;
-              ungrp.Nodes.Add(stn);
-            }
-          }
-        }
-        treeSlaveGroup.Nodes.Add(ungrp);
+        var top = BuildResourceTree(Content);
+        viewHost.Content = top;
       }
     }
@@ -140,5 +102,5 @@
       btnRemoveGroup.Enabled = enabled;
       btnSave.Enabled = enabled;
-      scheduleView.SetEnabledStateOfSchedule(enabled && IsAuthorized(slaveView.Content));
+      scheduleView.SetEnabledStateOfSchedule(enabled && IsAuthorized((Resource)viewHost.Content));
     }
     #endregion
@@ -164,5 +126,5 @@
         OnContentChanged();
         if (e.PropertyName == "HbInterval") {
-          UpdateChildHbIntervall(slaveView.Content);
+          UpdateChildHbIntervall((Resource)viewHost.Content);
         }
       }
@@ -212,11 +174,11 @@
     private async void btnRefresh_Click(object sender, EventArgs e) {
       lock (locker) {
-        if (updatingResources) return;
-        updatingResources = true;
+        if (!btnRefresh.Enabled) return;
+        btnRefresh.Enabled = false;
       }
 
       await SecurityExceptionUtil.TryAsyncAndReportSecurityExceptions(
         action: () => UpdateResources(),
-        finallyCallback: () => updatingResources = false);
+        finallyCallback: () => btnRefresh.Enabled = true);
     }
 
@@ -231,17 +193,17 @@
     private async void btnRemoveGroup_Click(object sender, EventArgs e) {
       lock (locker) {
-        if (removingResources) return;
-        removingResources = true;
+        if (!btnRemoveGroup.Enabled) return;
+        btnRemoveGroup.Enabled = false;
       }
 
       await SecurityExceptionUtil.TryAsyncAndReportSecurityExceptions(
         action: () => RemoveResource(),
-        finallyCallback: () => removingResources = false);
+        finallyCallback: () => btnRemoveGroup.Enabled = true);
     }
 
     private async void btnSave_Click(object sender, EventArgs e) {
       lock (locker) {
-        if (savingResources) return;
-        savingResources = true;
+        if (!btnSave.Enabled) return;
+        btnSave.Enabled = false;
       }
 
@@ -252,5 +214,5 @@
             resource.Store();
         },
-        finallyCallback: () => savingResources = false);
+        finallyCallback: () => btnSave.Enabled = true);
     }
 
@@ -258,8 +220,12 @@
       var selectedResource = (Resource)e.Node.Tag;
 
-      if (slaveView.Content != null && slaveView.Content is SlaveGroup)
-        slaveView.Content.PropertyChanged -= SlaveViewContent_PropertyChanged;
-
-      slaveView.Content = selectedResource;
+      if (viewHost.Content != null && viewHost.Content is SlaveGroup)
+        ((SlaveGroup)viewHost.Content).PropertyChanged -= SlaveViewContent_PropertyChanged;
+
+      viewHost.Content = selectedResource;
+      HiveAdminClient.Instance.DowntimeForResourceId = selectedResource != null ? selectedResource.Id : Guid.Empty;
+      await SecurityExceptionUtil.TryAsyncAndReportSecurityExceptions(
+        action: () => UpdateSchedule(),
+        finallyCallback: () => scheduleView.Content = HiveAdminClient.Instance.Downtimes);
 
       if (selectedResource != null && selectedResource is SlaveGroup)
@@ -269,79 +235,43 @@
         if (!tabSlaveGroup.TabPages.Contains(tabSchedule))
           tabSlaveGroup.TabPages.Add(tabSchedule);
-
-        HiveAdminClient.Instance.DowntimeForResourceId = selectedResource.Id;
-
-        if (tabSlaveGroup.SelectedIndex == 1) {
-          await SecurityExceptionUtil.TryAsyncAndReportSecurityExceptions(
-            action: () => UpdateSchedule(),
-            finallyCallback: () => scheduleView.Content = HiveAdminClient.Instance.Downtimes);
-        }
       } else {
         if (tabSlaveGroup.TabPages.Contains(tabSchedule))
           tabSlaveGroup.TabPages.Remove(tabSchedule);
-        HiveAdminClient.Instance.DowntimeForResourceId = Guid.Empty;
       }
     }
 
     private void treeSlaveGroup_DragDrop(object sender, DragEventArgs e) {
-      if (e.Data.GetDataPresent("System.Windows.Forms.TreeNode", false)) {
-        Point pt = ((TreeView)sender).PointToClient(new Point(e.X, e.Y));
-        TreeNode destNode = ((TreeView)sender).GetNodeAt(pt);
-        TreeNode newNode = (TreeNode)e.Data.GetData("System.Windows.Forms.TreeNode");
-
-        if (destNode.TreeView == newNode.TreeView) {
-          if (destNode.Text == UngroupedGroupName || (destNode.Parent != null && destNode.Parent.Text == UngroupedGroupName)) {
-            MessageBox.Show(string.Format("You can't drag items to the group \"{0}\".{1}This group only contains slaves which haven't yet been assigned to a real group.",
-              UngroupedGroupName, Environment.NewLine), "HeuristicLab Hive Administrator", MessageBoxButtons.OK, MessageBoxIcon.Information);
-            return;
-          }
-
-          SlaveGroup sgrp = null;
-          TreeNode parentNode = null;
-          if (destNode.Tag != null && destNode.Tag is SlaveGroup) {
-            sgrp = (SlaveGroup)destNode.Tag;
-            parentNode = destNode;
-          } else if (destNode.Parent != null && destNode.Parent.Tag is SlaveGroup) {
-            sgrp = (SlaveGroup)destNode.Parent.Tag;
-            parentNode = destNode.Parent;
-          }
-
-          if (newNode.Tag is SlaveGroup && CheckParentsEqualsMovedNode(parentNode, newNode)) {
-            return;
-          }
-
-          SlaveGroup parent = (SlaveGroup)parentNode.Tag;
-
-          if (parent.OwnerUserId != null && !IsAuthorized(parent)) {
-            MessageBox.Show(string.Format("You don't have the permissions to drag items to the group \"{0}\".", ((Resource)parentNode.Tag).Name),
-              "HeuristicLab Hive Administrator", MessageBoxButtons.OK, MessageBoxIcon.Error);
-            return;
-          }
-
-          if (sgrp != null && newNode.Tag != null) {
-            //save parent group to get an id
-            if (sgrp.Id == Guid.Empty) {
-              sgrp.Store();
-            }
-
-            if (newNode.Tag is Slave) {
-              Slave slave = (Slave)newNode.Tag;
-              if (slave.ParentResourceId == null || (slave.ParentResourceId != null && slave.ParentResourceId != sgrp.Id)) {
-                slave.ParentResourceId = sgrp.Id;
-                newNode.Remove();
-                parentNode.Nodes.Clear();
-                BuildSlaveGroupTree(sgrp, parentNode);
-              }
-            } else if (newNode.Tag is SlaveGroup) {
-              SlaveGroup slaveGroup = (SlaveGroup)newNode.Tag;
-              if (slaveGroup.ParentResourceId == null || (slaveGroup.ParentResourceId != null && slaveGroup.ParentResourceId != sgrp.Id)) {
-                slaveGroup.ParentResourceId = sgrp.Id;
-                newNode.Remove();
-                parentNode.Nodes.Clear();
-                BuildSlaveGroupTree(sgrp, parentNode);
-              }
-            }
-          }
-        }
+      var sourceNode = (TreeNode)e.Data.GetData(typeof(TreeNode));
+      if (sourceNode == null) return;
+
+      var treeView = (TreeView)sender;
+      if (sourceNode.TreeView != treeView) return;
+
+      var targetPoint = treeView.PointToClient(new Point(e.X, e.Y));
+      var targetNode = treeView.GetNodeAt(targetPoint);
+
+      if (sourceNode == targetNode) return;
+
+      if (targetNode.Text == ungroupedGroupName || targetNode.Parent != null && targetNode.Parent.Text == ungroupedGroupName) {
+        MessageBox.Show(
+          string.Format(@"You cannot drag resources to group ""{0}"". This group only contains slaves which have not been assigned to a real group yet.", ungroupedGroupName),
+          "HeuristicLab Hive Administrator",
+          MessageBoxButtons.OK,
+          MessageBoxIcon.Information);
+        return;
+      }
+
+      if (sourceNode.Parent == null)
+        treeView.Nodes.Remove(sourceNode);
+      else {
+        sourceNode.Parent.Nodes.Remove(sourceNode);
+        ((Resource)sourceNode.Tag).ParentResourceId = null;
+      }
+
+      if (targetNode == null) {
+        treeView.Nodes.Add(sourceNode);
+      } else {
+        targetNode.Nodes.Add(sourceNode);
+        ((Resource)sourceNode.Tag).ParentResourceId = ((Project)targetNode.Tag).Id;
       }
     }
@@ -364,28 +294,85 @@
       e.Action = DragAction.Continue;
     }
-
-    private void tabSlaveGroup_SelectedIndexChanged(object sender, EventArgs e) {
-      if (tabSlaveGroup.SelectedIndex == 1) {
-        UpdateSchedule();
-      }
-    }
     #endregion
 
     #region Helpers
-    private void BuildSlaveGroupTree(Resource g, TreeNode tn) {
-      foreach (Resource r in Content.Where(s => s.ParentResourceId != null && s.ParentResourceId == g.Id).OrderBy(x => x.Name)) {
-        TreeNode stn = new TreeNode(r.Name);
-        if (r is Slave) {
-          stn.ImageIndex = slaveImageIndex;
-        } else if (r is SlaveGroup) {
-          stn.ImageIndex = slaveGroupImageIndex;
-        }
-        stn.SelectedImageIndex = stn.ImageIndex;
-        stn.Tag = r;
-        if (r.OwnerUserId == Access.UserInformation.Instance.User.Id) stn.BackColor = ownedResourceColor;
-        tn.Nodes.Add(stn);
-
-        BuildSlaveGroupTree(r, stn);
-      }
+    private Resource BuildResourceTree(IEnumerable<Resource> resources) {
+      treeView.Nodes.Clear();
+      if (!resources.Any()) return null;
+
+      var slaveGroups = new HashSet<SlaveGroup>(resources.OfType<SlaveGroup>());
+      var slaves = new HashSet<Slave>(resources.OfType<Slave>());
+
+      var stack = new Stack<Resource>(slaveGroups.OrderByDescending(x => x.Name));
+      var top = stack.Peek();
+
+      TreeNode currentNode = null;
+      Resource currentResource = null;
+
+      while (stack.Any()) {
+        var newResource = stack.Pop();
+        var newNode = new TreeNode(newResource.Name) { Tag = newResource };
+
+        while (currentNode != null && newResource.ParentResourceId != currentResource.Id) {
+          currentNode = currentNode.Parent;
+          currentResource = currentNode == null ? null : (Resource)currentNode.Tag;
+        }
+
+        if (currentNode == null) {
+          treeView.Nodes.Add(newNode);
+        } else {
+          currentNode.Nodes.Add(newNode);
+        }
+
+        if (newResource is Slave) {
+          newNode.ImageIndex = slaveImageIndex;
+        } else {
+          newNode.ImageIndex = slaveGroupImageIndex;
+
+          var childSlaves = slaves.Where(x => x.ParentResourceId == newResource.Id);
+          foreach (var slave in childSlaves.OrderBy(x => x.Name)) {
+            slaves.Remove(slave);
+            var slaveNode = new TreeNode(slave.Name) { Tag = slave };
+
+            slaveNode.SelectedImageIndex = slaveNode.ImageIndex = slaveImageIndex;
+            if (slave.OwnerUserId == UserInformation.Instance.User.Id)
+              slaveNode.BackColor = ownedResourceColor;
+
+            newNode.Nodes.Add(slaveNode);
+          }
+
+          var childSlaveGroups = slaveGroups.Where(x => x.ParentResourceId == newResource.Id);
+          if (childSlaveGroups.Any()) {
+            foreach (var slaveGroup in childSlaveGroups.OrderByDescending(x => x.Name)) {
+              slaveGroups.Remove(slaveGroup);
+              stack.Push(slaveGroup);
+            }
+            currentNode = newNode;
+            currentResource = newResource;
+          }
+        }
+
+        newNode.SelectedImageIndex = newNode.ImageIndex;
+        if (newResource.OwnerUserId == UserInformation.Instance.User.Id)
+          newNode.BackColor = ownedResourceColor;
+      }
+
+      var ungroupedNode = new TreeNode(ungroupedGroupName) {
+        ForeColor = SystemColors.GrayText,
+        Tag = new SlaveGroup() {
+          Name = ungroupedGroupName,
+          Description = ungroupedGroupDescription
+        }
+      };
+
+      foreach (var slave in slaves.OrderBy(x => x.Name)) {
+        var slaveNode = new TreeNode(slave.Name) { Tag = slave };
+        ungroupedNode.Nodes.Add(slaveNode);
+      }
+
+      treeView.Nodes.Add(ungroupedNode);
+      treeView.ExpandAll();
+
+      return top;
     }
 
@@ -414,11 +401,11 @@
       if (InvokeRequired) Invoke((Action)ResetView);
       else {
-        treeSlaveGroup.Nodes.Clear();
-
-        if (slaveView.Content != null && slaveView.Content is SlaveGroup) {
-          slaveView.Content.PropertyChanged -= SlaveViewContent_PropertyChanged;
-        }
-
-        slaveView.Content = null;
+        treeView.Nodes.Clear();
+
+        if (viewHost.Content != null && viewHost.Content is SlaveGroup) {
+          ((SlaveGroup)viewHost.Content).PropertyChanged -= SlaveViewContent_PropertyChanged;
+        }
+
+        viewHost.Content = null;
         if (scheduleView.Content != null) {
           scheduleView.Content.Clear();
@@ -435,5 +422,5 @@
 
     private void RemoveResource() {
-      var selectedNode = treeSlaveGroup.SelectedNode;
+      var selectedNode = treeView.SelectedNode;
       if (selectedNode == null || selectedNode.Tag == null) return;
 
@@ -474,5 +461,5 @@
     private bool IsAuthorized(Resource resource) {
       return resource != null
-          && resource.Name != UngroupedGroupName
+          && resource.Name != ungroupedGroupName
           && resource.Id != Guid.Empty
           && UserInformation.Instance.UserExists
